Developer Documentation

Public Member Functions | Public Attributes | Private Attributes | List of all members
ACG::DrawMeshFaceInput< Mesh > Class Template Reference
Inheritance diagram for ACG::DrawMeshFaceInput< Mesh >:

## Public Member Functions
| DrawMeshFaceInput (Mesh &_mesh)
int | getNumFaces () const
int | getNumIndices () const
int | getFaceSize (const int _faceID) const
int | getSingleFaceAttr (const int _faceID, const int _faceCorner, const int _attrID) const
bool | getFaceAttr (const int _faceID, const int _attrID, int *_out) const
int * | getFaceAttr (const int _faceID, const int _attrID) const
int | getVertexAdjCount (const int _vertexID) const
int | getVertexAdjFace (const int _vertexID, const int _k) const

## Public Attributes
std::vector< int > | attributeStoredPerHalfedge_

## Private Attributes
Mesh & | mesh_

## Detailed Description

### template<class Mesh>
class ACG::DrawMeshFaceInput< Mesh >

Definition at line 245 of file DrawMeshT_impl.hh.

## Member Function Documentation

## ◆ getFaceAttr() [1/2]

template<class Mesh>

bool ACG::DrawMeshFaceInput< Mesh >::getFaceAttr | ( | const int | _faceID,
|  | const int | _attrID,
|  | int * | _out
| ) |  | const
| inline virtual

Get an index buffer of a face for a specific attribute channel.

Parameters

  _faceID | face index
  _attrID | attribute channel
  _out | pointer to output buffer, use getFaceSize(_faceID) to get the size needed to store face data

Returns
  true if successful, false otherwise

Reimplemented from ACG::MeshCompilerFaceInput.

Definition at line 341 of file DrawMeshT_impl.hh.

## ◆ getFaceAttr() [2/2]

template<class Mesh>

int* ACG::DrawMeshFaceInput< Mesh >::getFaceAttr | ( | const int | _faceID,
|  | const int | _attrID
| ) |  | const
| inline virtual

Get an index buffer of a face for a specific attribute channel.

Parameters

  _faceID | face index
  _attrID | attribute channel

Returns
  array data of size "getFaceSize(_faceID)", allowed to return 0 when array data not permanently available in memory

Reimplemented from ACG::MeshCompilerFaceInput.

Definition at line 362 of file DrawMeshT_impl.hh.

## ◆ getFaceSize()

template<class Mesh>

int ACG::DrawMeshFaceInput< Mesh >::getFaceSize | ( | const int | _faceID | ) | const
| inline virtual

Get number of vertices per face.

Parameters

  _faceID | face index

Implements ACG::MeshCompilerFaceInput.

Definition at line 267 of file DrawMeshT_impl.hh.

## ◆ getNumIndices()

template<class Mesh>

int ACG::DrawMeshFaceInput< Mesh >::getNumIndices | ( |  | ) | const
| inline virtual

Get total number of indices in one attribute channel.

i.e. total number of position indices of the whole mesh

Implements ACG::MeshCompilerFaceInput.

Definition at line 262 of file DrawMeshT_impl.hh.

## ◆ getSingleFaceAttr()

template<class Mesh>

int ACG::DrawMeshFaceInput< Mesh >::getSingleFaceAttr | ( | const int | _faceID,
|  | const int | _faceCorner,
|  | const int | _attrID
| ) |  | const
| inline virtual

Get a single vertex-index entry of a face.

Parameters

  _faceID | face index
  _faceCorner | vertex corner of the face
  _attrID | attribute channel

Returns
  index-data if successful, -1 otherwise

Reimplemented from ACG::MeshCompilerFaceInput.

Definition at line 279 of file DrawMeshT_impl.hh.

## ◆ getVertexAdjCount()

template<class Mesh>

int ACG::DrawMeshFaceInput< Mesh >::getVertexAdjCount | ( | const int | _vertexID | ) | const
| inline virtual

Get the number of adjacent faces for a vertex.

Parameters

  _vertexID | vertex index

Returns
  number of adjacent faces, return -1 if adjacency information unavailable

Reimplemented from ACG::MeshCompilerFaceInput.

Definition at line 370 of file DrawMeshT_impl.hh.

## ◆ getVertexAdjFace()

template<class Mesh>

int ACG::DrawMeshFaceInput< Mesh >::getVertexAdjFace | ( | const int | _vertexID,
|  | const int | _k
| ) |  | const
| inline virtual

Get the index of an adjacent face for a vertex.

Parameters

  _vertexID | vertex index
  _k | adjacency list entry in range [0, .., adjCount - 1]

Returns
  face id of adjacent face, return -1 if adjacency information is available

Reimplemented from ACG::MeshCompilerFaceInput.

Definition at line 384 of file DrawMeshT_impl.hh.

The documentation for this class was generated from the following file:

- OpenFlipper/libs_required/ACG/GL/DrawMeshT_impl.hh